#include <iostream.h>

class PuntoVendita;   /* la classe SedeCentrale  definita nel seguito del codice*/


class Sede 
{
	private:
		int TotaleVendite;
	public:
		Sede();
		friend void Aggiorna(PuntoVendita *P, Sede *S);   //dichiarazione della funzione amica esterna

};  /* fine dichiarazione classe Sede*/

class PuntoVendita 
{
	private:
		int TotVenditaNegozio;		
		int CodiceNegozio;
	public:
		PuntoVendita(int Num);
		void Vendita(int Qta);
		friend void Aggiorna(PuntoVendita *P, Sede *S);   //dichiarazione della funzione amica esterna
	
};  /* fine dichiarazione classe PuntoVendita*/

int main() 
{
	Sede *S1 = new Sede();  /* crea una nuova sede centrale*/
	PuntoVendita *P1 = new PuntoVendita(1);  /* crea il punto vendita 1*/
  	P1->Vendita(5);			/* trasmette le vendite alla sede centrale*/
	Aggiorna(P1, S1);		/* aggiorna le vendite totali della sede centrale */
	PuntoVendita *P2 = new PuntoVendita(2);  /* crea il punto vendita 2*/
  	P2->Vendita(20);			/* trasmette le vendite alla sede centrale*/
	Aggiorna(P2, S1);		/* aggiorna le vendite totali della sede centrale */
	return 0;
} 

Sede::Sede()
{
	TotaleVendite=0;
}

PuntoVendita::PuntoVendita(int Num)
{
	CodiceNegozio = Num;
	TotVenditaNegozio = 0;
}

void PuntoVendita::Vendita(int Qta)
{
	TotVenditaNegozio = TotVenditaNegozio + Qta;
}

void Aggiorna(PuntoVendita *P, Sede *S)    // definizione della funzione amica
{
	S->TotaleVendite = S->TotaleVendite + P->TotVenditaNegozio;
	cout << "Vendita del negozio " << P->CodiceNegozio << ": " << P->TotVenditaNegozio << endl;
	cout << "Totale vendite: " << S->TotaleVendite << endl;
}
